;     "60-2"
;   ,     
;     .
			LIST        p=16F684   ;   .
            include "p16f684.inc"
            errorlevel  -302
            __CONFIG    3C4h ;   , WDT ,  
                                    ;  XT;   . 
; ""   .
;===============================================================================================
Temp_L			equ			70h         ;   - 
Temp_H          equ         71h         ; 
Temp1_L         equ         72h         ;    
Temp1_H			equ         73h
Flag			equ         74h			;   
Zub             equ         75h			;    
W_Temp          equ         76h         ; 
Stat_Temp       equ         77h         ; 
Temp2_L			equ			78h
Temp2_H			equ			79h

;===============================================================================================

;     .
;===============================================================================================
F          		equ         1           ;    .
W           	equ         0           ;   

;================================================================================
;     .
;================================================================================
         	org  		   0           ;     PC   
            goto       	START          ;    .
            org            4           ;     c , 
                                   	   ; ,  PC,    04h.
;********************************************************************************


;================================================================================
;  .
;================================================================================
;     .
;---------------------------------------
			
			btfsc      PIR1,TMR1IF   ;     TMR1 
                                     ;   ?
            goto       WRITE_0       ;  ,    
            btfss      Flag,0      ;
            goto       WRITE_1     ;   =0,   
                                   ;  1. 
                                   ;   =1,   
                                   ;  2.

			btfsc		Flag,1       ;  ,                   
            goto		PULSE		;      1 
;--------------------------------------------------------------------------------
;  
;--------------------------------------------------------------------------------
            movf       Temp_L,W
            movwf      Temp1_L
            movf       Temp_H,W
            movwf      Temp1_H
            movf       CCPR1L,W    ;   CCPR1L
            movwf      Temp_L      ;    Temp_L.
            movf       CCPR1H,W    ;   CCPR1H
            movwf      Temp_H      ;    Temp_H.
            movlw      .19         ; 
            movwf      TMR1L       ; 
            clrf       TMR1H       ; TMR1H/TMR1L.()
;================================================================================
;   
;================================================================================
;   Temp1_H/Temp1_L( )  2.(  0)
;--------------------------------------------------------------------------------
			movf		Temp1_L,W	 ;  0
		    iorwf		Temp1_H,W
			btfsc		STATUS,Z
			goto		VIHOD1		 ; 
			bcf         STATUS,C     ;   .
            rlf         Temp1_L,F    ;     Temp1_L.
            rlf         Temp1_H,F    ;     Temp1_H.
            movf		Temp1_L,W
            movwf		Temp2_L
            movf		Temp1_H,W
            movwf		Temp2_H
            bcf			STATUS,C
            rlf			Temp2_L,F
            rlf			Temp2_H,F
;***********************************************************************************************
;      .
;***********************************************************************************************
			movfw		Temp_L		;  2Temp_1-Temp
  			subwf		Temp1_L,W
  			movfw 		Temp_H
  			btfss 		STATUS,C  	; c=0 ,     ,  
    		incfsz 		Temp_H,W 	; handle xh=0xff correctly, unlike ``incf xh,w''.
      		subwf 		Temp1_H,W
  			btfsc 		STATUS,C	; 2*Temp_1 < Temp
    		goto 		VIHOD1		; ,   
			
			movfw		Temp_L		;   
			subwf		Temp2_L,W	; 
			movfw		Temp_H		;   
			btfss		STATUS,C
			incfsz		Temp_H,W	; ,   FF
			subwf		Temp2_H,W
			btfss		STATUS,C	;4Temp_1 > Temp
			goto		VIHOD1  	; ,   
           
            bsf			Flag,1
ZUB1        clrf		Zub			;    1
			goto		VIHOD       ;   1
;-----------------------------------
VIHOD1		bcf         PIR1,CCP1IF ;      CCP.
            clrwdt					;   
            retfie                  ;   .
;--------------------------------------------------------------------------------
VIHOD       bcf         PIR1,TMR1IF ;      TMR1.
            bcf         PIR1,CCP1IF ;      CCP.
            clrwdt					;   
            retfie                  ;   .           
;--------------------------------------------------------------------------------
; 
WRITE_0		clrf		PORTA		;    
			clrf		PORTC
			clrf		Flag		;  
            clrf		Temp_L
            clrf		Temp_H                       
            bcf         PIR1,TMR1IF ;      TMR1.
            bcf         PIR1,CCP1IF ;      CCP.
            clrwdt					;   
            retfie                  ;   .
;********************************************************************************
WRITE_1     movlw       .10          ; 
            movwf       TMR1L       ; 
            clrf        TMR1H       ; TMR1H/TMR1L.
            bsf         Flag,0 	   ; Y   
            clrf		Temp_L
            clrf		Temp_H 
            goto		VIHOD1                      
;********************************************************************************
PULSE		btfsc		Flag,3
			goto		PULSE1
			movf        Temp_L,W
            movwf       Temp1_L
            movf        Temp_H,W
            movwf       Temp1_H
            movf        CCPR1L,W    ;   CCPR1L
            movwf       Temp_L      ;    Temp_L.
            movf        CCPR1H,W    ;   CCPR1H
            movwf       Temp_H      ;    Temp_H.
            movlw       .22         ; 
            movwf       TMR1L       ; 
            clrf        TMR1H       ; TMR1H/TMR1L.()

			bcf         STATUS,C     ;   .
            rlf         Temp1_L,F    ;     Temp1_L.
            rlf         Temp1_H,F    ;     Temp1_H.
			
			movf		Temp_H,W	; 2Temp_1-Temp
			subwf		Temp1_H,F
			movf		Temp_L,W
			subwf		Temp1_L,W
			btfss		STATUS,C
			decf		Temp1_H,F
			
			btfsc		Temp1_H,7	; 2*Temp_1 > Temp
			goto		ZUB1
PULSE1		incf        Zub,F
;-------------------------------------------------------------------------
;   .
;-------------------------------------------------------------------------
			movf	    Zub,W	
			addwf       PCL,F       ;  .
            goto	    VIHOD       ; 1        clrf Zub!
            goto	    VIHOD       ; 2 
            goto	    VIHOD 		; 3
            goto	    VIHOD		; 4
            goto	    VIHOD		; 5
            goto	    VIHOD       ; 6
            goto	    VIHOD		; 7
            goto	    VIHOD 		; 8
            goto	    VIHOD		; 9
            goto	    VIHOD		; 10
            goto	    VIHOD		; 11
            goto	    VIHOD		; 12
            goto	    VIHOD 		; 13
            goto	    VIHOD		; 14
            goto	    VIHOD		; 15
            goto	    VIHOD		; 16
            goto	    VIHOD		; 17
            goto	    VIHOD 		; 18
            goto	    VIHOD		; 19
            goto	    VIHOD		; 20
            goto	    VIHOD       ; 21
            goto	    VIHOD		; 22
            goto	    VIHOD		; 23
            goto	    VIHOD		; 24
            goto	    VIHOD		; 25
            goto	    VIHOD		; 26
            goto	    VIHOD		; 27
            goto	    VIHOD		; 28
            goto	    VIHOD		; 29
            goto	    VIHOD		; 30
            goto	    VIHOD		; 31
            goto	    VIHOD		; 32
            goto	    VIHOD 		; 33
            goto	    VIHOD		; 34
            goto	    VIHOD		; 35
            goto	    VIHOD		; 36
            goto	    VIHOD		; 37
            goto	    VIHOD 		; 38
            goto	    VIHOD		; 39
            goto	    VIHOD		; 40
            goto	    VIHOD		; 41
            goto	    VIHOD		; 42
            goto	    VIHOD		; 43
            goto	    VIHOD		; 44
            goto	    VIHOD		; 45
            goto	    VIHOD		; 46
            goto	    VIHOD		; 47
            goto	    VIHOD 		; 48
            goto	    VIHOD		; 49
            goto	    VIHOD		; 50
            goto	    VIHOD		; 51
            goto	    VIHOD		; 52
            goto	    VIHOD		; 53
            goto	    VIHOD		; 54
            goto	    VIHOD		; 55
            goto		VIHOD		; 56
            goto		Z57			; 57
            goto		Z58			; 58
            goto		Z59			; 59
            goto		Z60			; 60
         
;-----------------------------------------------
Z57			bsf			Flag,3
			goto		VIHOD1
;-----------------------------------------------
Z58			movf        CCPR1L,W    ;   CCPR1L
            movwf		Temp_L		;   1 
            movwf       Temp1_L     ;    Temp_L.
            movf        CCPR1H,W    ;   CCPR1H
            movwf		Temp_H		;  . 1 
            movwf       Temp1_H     ;    Temp_H.
            
            clrf        CCP1CON     ;   CCP
            movlw       b'00001010' ; P > 
            movwf       CCP1CON
            movlw       .30         ;  
            movwf       TMR1L       ; 
            clrf        TMR1H       ; TMR1H/TMR1L.()
            goto	    VIHOD1
;-----------------------------------------------
;   Temp1_H/Temp1_L( )  2.(  0)
;--------------------------------------------------------------------------------
Z59			bcf         STATUS,C     ;   .
            rlf         Temp1_L,F    ;     Temp1_L.
            rlf         Temp1_H,F    ;     Temp1_H.
            movf		Temp1_H,W
            movwf		CCPR1H		 ;  
            movf		Temp1_L,W	 ;   
            movwf		CCPR1L		 ; 60 
            goto		VIHOD1
            			
;-----------------------------------------------
Z60			
			clrf        CCP1CON     ;   CCP 
            movlw       b'00000100' ;    
            movwf       CCP1CON     ;     RB3.
            bcf		    Flag,1	   ;  , 1-   
			bcf			Flag,3 
            goto		VIHOD1
;-----------------------------------------------						
START       clrf        INTCON      ;   .
			clrf		PORTA
	    	clrf		PORTC
			bsf			STATUS,RP0		; Bank 1
			movlw		b'01101111'
			movwf		OSCCON		    ; Internal oscillator frequeny = 4 MHz
			clrf		TRISA		    ; RA3    !
			
			clrf		ANSEL
			bcf         STATUS,RP0  ;   0- .
            movlw       7           ;  
            movwf       CMCON0       ; .
            movlw       b'00000001' ; TMR1 ,  ,
            movwf       T1CON       ; .  = 1(    
            ; F osc   . , . 16  1:4

;--------------------------------------
;   CCP.
;--------------------------------------
            clrf        CCP1CON     ;   CCP 
                                   ; ( ).
            movlw       b'00000100' ;    
            movwf       CCP1CON     ;     RB3.
;--------------------------------------
;      CCP.
;--------------------------------------
            bcf         PIR1,CCP1IF ;   CCP1IF.
;--------------------------------------------------------------------------------
;     CCP,   
;  WDT      CCP.
;--------------------------------------------------------------------------------
            clrwdt                            ;  WDT.
            clrf        Flag                  ;     Flag.
            clrf		Temp_L
            clrf		Temp_H
            clrf        TMR1H
			clrf		TMR1L 
			bcf         PIR1,TMR1IF 		  ;      TMR1.
            movlw       b'11000000'  		  ;    
            movwf       INTCON                ;    
                                              ; .
            bsf         STATUS,RP0            ;   1- .
            movlw		b'00001100'			  ;    WDT (=16).
            movwf       OPTION_REG			  ;   
            movlw		b'00100000'				  ; RC5  
			movwf		TRISC
            					              ;     CCP
                                              ; ( ).
            movlw       b'00100001'           ;  
            movwf       PIE1                  ;   CCP   TMR1()
            bcf         STATUS,RP0            ;   0- .
			clrf		PORTC                 ;  
			clrf		PORTA
;--------------------------------------------------------------------------------
; ""  .
;--------------------------------------------------------------------------------
            goto        $         ; .
;--------------------------------------------------------------------------------
 end

			





















